echo $(upperme): $@ >&2
}
-if [ $(pidof -x $(basename $0) | wc -w) -gt 2 ]; then
- scottyerror Another instance of $(basename $0) is already running!
- exit 1
-fi
-
-while getopts "qn:" opt; do
- case $opt in
- q)
- exec > /dev/null
- ;;
- n)
- BACKUP_RUNEVERYNTHDAY=$OPTARG
- ;;
- esac
-done
-
function grepbackups {
ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
}
fi
}
-function isIncompleteOrNthDay {
- if isIncomplete || \
- [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
+function isNthDay {
+ if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
then
return 0
else
fi
}
+function latestTooOld {
+ for oldbackup in $(grepbackups); do
+ tstamp=$(echo $oldbackup | cut -d'-' -f1)
+
+ if [ $(( $(date +%s) - $tstamp )) -lt \
+ $(( $BACKUP_RUNEVERYNTHDAY*24*60*60 )) ]
+ then
+ return 1
+ fi
+ done
+
+ return 0
+}
+
function scottysync {
timestamp=$(date +%s)
done
}
-function prepare {
- scottyinfo "Preparing for sync"
+function deleteLock {
+ if ! rmdir /tmp/$(basename $0).lock; then
+ scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
+ fi
}
-function cleanup_abrt {
- scottyinfo "No cleanup_abrt function was defined."
+function prepare {
+ scottyinfo "Preparing for sync"
}
-function _cleanup_abrt {
+function cleanup_abort {
scottyerror "Caught exit signal! Cleaning up..."
- cleanup_abrt
+
+ cleanup ABORT
+
if [ $(jobs -p) ]; then
scottyerror TERMinating remaining child processes...
kill $(jobs -p)
fi
+
+ deleteLock
+
exit
}
-function prepare {
- scottyinfo "No prepare function was defined."
+function cleanup {
+ scottyinfo "No cleanup function was defined."
}
-function _prepare {
- prepare
+function prepare {
+ scottyinfo "No prepare function was defined."
}
function cleanup_normal {
- scottyinfo "No cleanup_normal function was defined."
+ cleanup
+ deleteLock
}
-function _cleanup_normal {
- cleanup_normal
+function printhelp {
+ cat <<EOF
+Usage: $(basename $0) [OPTION]...
+
+Recognized options:
+ -q Only output errors
+ -n Run only on nth day
+ -h Print out this help
+EOF
}
function backmeupscotty {
- if ! isIncompleteOrNthDay; then
- scottyinfo "This is not the nth day and no incomplete backup exists."
+ while getopts "qn:h" opt; do
+ case $opt in
+ q)
+ exec > /dev/null
+ ;;
+ n)
+ BACKUP_RUNEVERYNTHDAY=$OPTARG
+ ;;
+ h)
+ printhelp
+ exit 0
+ ;;
+ esac
+ done
+
+ if (! ssh -q $REMOTE_HOST exit); then
+ scottyerror "Could not establish SSH connection to $REMOTE_HOST!"
+ exit 1
+ fi
+
+ if isNthDay; then
+ scottyinfo "This is the nth day."
+ elif latestTooOld; then
+ scottyinfo "The latest backup is too old."
+ else
+ scottyinfo "No backup has to be done. Exiting."
exit 0
fi
- trap _cleanup_abrt EXIT
+ scottyinfo "Performing backup."
- _prepare
+ trap cleanup_abort EXIT
+
+ prepare
scottysync
- _cleanup_normal
- trap - EXIT
+ trap cleanup_normal EXIT
+
+ exit 0
}
+
+if ! mkdir /tmp/$(basename $0).lock; then
+ scottyerror "Another instance of $(basename $0) is still running!"
+ exit 1
+else
+ trap deleteLock EXIT
+fi